package com.calebfontenot;

import com.calebfontenot.parsers.Velocity;

import java.util.*;


public class Main {

    //TODO: Move these into the parser classes?
    public static final String PAPER_API_URL = "https://api.papermc.io/v2";


    public static void main(String[] args) throws Exception {
        for (int i = 0; i < args.length; i++) {
            System.out.println("args used: " + args[i]);
        }
        // Check if user passed arguments, if none have been passed, go into interactive mode:
        if (args.length == 0) {
            menu();
        } else if (args[0].equals("download")) {
            if (args[1].equals("modrinth")) {
                Velocity.fetchVersions(args[2]);
            }
        }
        /*
        List<String> projects = Common.parse("https://api.papermc.io/v2/projects", "projects");
        System.out.println("The projects returned by Common.parse() are: ");
        for(String projectNames:projects) {
            System.out.println(projectNames);
        }
         */
    }

    public static void menu() throws Exception {
        Scanner input = new Scanner(System.in);
        int userInput;
        System.out.println("No arguments passed, entering interactive mode!");
        System.out.println("Note: Typing '-1' at any point in this menu will exit the program.");
        do {
            System.out.println("What would you like to do?");
            System.out.println("1. Download a jar file from a parser.");
            System.out.println("2. Obtain information from an API.");
            userInput = input.nextInt();
            if (userInput == 1) { // Download

            } else if (userInput == 2) { // Obtain info
                System.out.println("Selected: Obtain info");
                System.out.println("Select which parser to use:");
                System.out.println("1. PaperMC (Not finished)");
                System.out.println("2. Modrinth");
                userInput = input.nextInt();
                if (userInput == 1) { // user has selected PaperMC
                    System.out.println("Available Projects: ");
                    List<String> projects = Common.parseKey(PAPER_API_URL + "/projects", "projects");
                    int i = 1;
                    for (String projectNames : projects) {
                        System.out.println(i + ". " + projectNames);
                        i++;
                    }
                    System.out.print("Select project: ");
                    userInput = input.nextInt();
                    System.out.println(Common.rawFetch(PAPER_API_URL + "/projects/" + projects.get(userInput - 1)));
                }
                if (userInput == 2) {
                    System.out.println("What would you like to do?");
                    System.out.println("1. Search for mods");
                    System.out.println("2. Get info about a slug/ID");
                    userInput = input.nextInt();
                    if(userInput == 1) {
                        System.out.print("Enter query:");
                        String inputString = input.next();
                        System.out.println(Common.rawFetch(com.calebfontenot.parsers.Velocity.MODRINTH_API_URL + "/search?query=" + inputString));
                    }
                    if(userInput == 2) {
                        System.out.print("Enter slug/ID: ");
                        String inputString = input.next();
                        System.out.println(Common.rawFetch(com.calebfontenot.parsers.Velocity.MODRINTH_API_URL + "/project/" + inputString + "/version"));
                    }

                }

            }

        } while (userInput != -1);
    }
}